(:~
 : Global constants and functions.
 :
 : @author Rave Technologies, https://www.rave-tech.com/, 2017
 :)

module namespace 		cpsrv    	= 'http://www.rave-tech.com/bloomsbury/config-psrv';
import module namespace Session 	= 'http://basex.org/modules/session';


(:~ Processing Server. :)
declare variable $cpsrv:DataServer as xs:string		:= 'http://172.20.2.16:8984/rest/';
declare variable $cpsrv:User as xs:string			:= 'admin';
declare variable $cpsrv:Password as xs:string		:= 'admin';
declare variable $cpsrv:ReadyToMove as xs:string	:= '/ReadyToMove/';

(:~ Main Database. :)
declare variable $cpsrv:Database as xs:string		:= 'bloomsbury';

(:~ Debug on/off. :)
declare variable $cpsrv:Debug as xs:boolean		:= fn:true();

(:~ Main Directories of the application. :)
(:~ User Directory. :)
declare variable $cpsrv:UserDir as xs:string 		:= '/user/';
(:~ Taxonomy Directory. :)
declare variable $cpsrv:TaxonomyDir as xs:string 	:= '/taxonomies/';
(:~ Configuration Directory. :)
declare variable $cpsrv:ConfigDir as xs:string 		:= '/config/';
(:~ Pipeline Directory. :)
declare variable $cpsrv:PipelineDir as xs:string 	:= '/pipelines/';
(:~ Transformation Directory. :)
declare variable $cpsrv:TransformDir as xs:string 	:= '/transforms/';
(:~ Validation Directory. :)
declare variable $cpsrv:ValidationDir as xs:string := '/validation/';
(:~ Product Directory. :)
declare variable $cpsrv:ProductDir as xs:string 	:= '/products/';
(:~ Content Directory. :)
declare variable $cpsrv:ContentDir as xs:string 	:= '/content/';
(:~ Latest Directory to keep latest version. :)
declare variable $cpsrv:LatestDir as xs:string 		:= '/latest/';
(:~ Jobs Directory. :)
declare variable $cpsrv:JobDir as xs:string 		:= '/jobs/';
(:~ docx Directory. :)
declare variable $cpsrv:WordDir as xs:string 		:= '/word/';
(:~ Version Directory to keep old version. :)
declare variable $cpsrv:VersionDir as xs:string 	:= '/version/';
(:~ metadata Directory to keep content metadata xml. :)
declare variable $cpsrv:Metadata as xs:string 	:= '/metadata/';
(:~ Audit Directory. :)
declare variable $cpsrv:AuditDir as xs:string 		:= 'audit/';
(:~ Report Directory. :)
declare variable $cpsrv:ReportDir as xs:string 	:= '/reports/';
(:~ To keep lock information. :)
declare variable $cpsrv:LockDir as xs:string 	:= '/locks/';
(:~ Temp Directory. :)
declare variable $cpsrv:TempDir as xs:string 			:= '\\172.20.2.16\bloomsbury-CMS\bl-workspace\'; 
(:~ Pipeline output directory for temp :)
declare variable $cpsrv:TempPipelineDir as xs:string 	:= fn:concat($cpsrv:TempDir,'pipeline_output/');
declare variable $cpsrv:SchemaDir as xs:string 	:= 'file:///D:/schemas/';
declare variable $cpsrv:XsdDir as xs:string 	:= '\\172.20.2.16\schemas\';
declare variable $cpsrv:XprocTempResultDir as xs:string 	:= 'file:///D:/bloomsbury-CMS/';

declare variable $cpsrv:SchemaxplLocation := "file:///D:/xproc/calabash/extensions/transpect/rng-extension/xpl/rng-validate.xpl";




(:~ Global prefixes  :)
(:~ Job ID prefix. :)
declare variable $cpsrv:JobIDPrefix as xs:string 			:= "SCH";


(:~ Global file name  :)
(:~ Common file name to keep audit information :)
declare variable $cpsrv:AuditFileName as xs:string				:= 'audit.xml';
(:~ Common file name to keep version control :)
declare variable $cpsrv:VersionControlFileName as xs:string	:= 'version.xml';
(:~ DOC XML Path :)
declare variable $cpsrv:DocXml as xs:string					:= "word/document.xml";
(:~ Looseleaf header file :)
declare variable $cpsrv:HeaderXml as xs:string				:= "header.xml";
(:~ To keep extra information of the documents: like Area/Content Type :)
declare variable $cpsrv:InfoXml as xs:string 				:= 'properties.xml';
(:~ To keep content metadata information :)
declare variable $cpsrv:MetaXml as xs:string 				:= 'metadata.xml';
(:~ To keep content classify information :)
declare variable $cpsrv:ClassifyXml as xs:string 			:= 'classify.xml';

(:~ Configurable XML files location  :)
declare variable $cpsrv:PipelineConfig as xs:string	:= fn:concat($cpsrv:ConfigDir,'ingest-pipeline-config.xml');
(:~ Pipeline Configuration file path :)
declare variable $cpsrv:DownloadConfig as xs:string	:= fn:concat($cpsrv:ConfigDir,'content-download.xml');


(:~ Global path to support XProc, Temp, and Published folder directory :)
(:~ XProc: The path where calabash.bat file exist :)
declare variable $cpsrv:CalabashBatch as xs:string		:= '\\172.20.2.16\SharedData\xproc\calabash\calabash.bat';
(:~ Output Directory to store downloaded content. :)
declare variable $cpsrv:OutDir as xs:string 			:= 'C:\Program Files (x86)\BaseX\output\download\';
(:~ Output Directory to store published content. :)
declare variable $cpsrv:PublishDir as xs:string 		:= 'C:\Program Files (x86)\BaseX\output\publish\';
declare variable $cpsrv:bloomsburydbk as xs:string 		:= '\transpact-dbk-to-bloomsbury-dbk\';
(:~
 : Display debug message in serer log
 : @param message The message to print in log file
 : @return empty sequence
:)
declare %updating function cpsrv:update-message(
	$message as xs:string
)
{
	if($cpsrv:Debug)
	then admin:write-log($message)
	else ()
};

(:~
 : Display debug message in serer log
 : @param message The message to print in log file
 : @return empty sequence
:)
declare function cpsrv:non-update-message(
	$message as xs:string
)
{
	if($cpsrv:Debug)
	then admin:write-log($message)
	else ()
};
